# template name attributes
%define slesver 11
%define	distrover sles
%define templatename sles
%define templatever %slesver
%define templatearch x86_64
%define technologies sysfs
%define distribution sles
# kernel from suse
%define osrelease 3.0.101
%define osenvironment YAST_IS_RUNNING=instsys

# Human-readable attributes
%define fullname SUSE Linux Enterprise Server %templatever
%define fulltemplatearch (for AMD64/Intel EM64T)

# template dirs
%define templatedir /vz/template/%templatename/%templatever/%templatearch/config
%define ostemplatedir %templatedir/os/default

# vzpkgenv related
%define pkgman zypp44x64
%define package_manager rpm%pkgman
%define package_manager_pkg vzpkgenv%pkgman >= 7.0.0

# Files lists
%define files_lst() \
find %1 -type d -printf '%%%dir %%%attr(%m,root,root) %p\\n' | sed "s,%buildroot,,g" >> %2\
find %1 -type f -printf '%%%config %%%attr(%m,root,root) %p\\n' | sed "s,%buildroot,,g" >> %2\
%nil

# Sources list
%define sources_lst() \
%((cd %_sourcedir;\
s=1;\
for tmpl in %1; do\
sources=$tmpl"_*";\
for file in $sources; do\
echo Source$s: $file;\
s=$((s+1))\
done;\
done))\
%nil

# Obsoletes list
%define obsoletes_lst() \
%((for tmpl in %1; do\
[ $tmpl = os ] && continue;\
echo "Obsoletes: $tmpl-%templatename-%templatever-%templatearch-ez < 7.0.0";\
echo "Provides: $tmpl-%templatename-%templatever-%templatearch-ez = %version-%release";\
done))\
%nil

# Templates list - packages file should be always present in any template!
%define templates_list() %((cd %_sourcedir; for f in *_packages; do echo -n "${f%_*} "; done))

Summary: %fullname %fulltemplatearch Template set
Name: %templatename-%templatever-%templatearch-ez
Group: Virtuozzo/Templates
License: GPL
Version: 7.0.0
Release: 11%{?dist}
BuildRoot: %_tmppath/%name-root
BuildArch: noarch
Requires: %package_manager_pkg

# template source files
%sources_lst %templates_list

# obsoletes
%obsoletes_lst %templates_list

%description
%fullname %fulltemplatearch packaged as a Virtuozzo Template set.

%install
installfile() {
	local sourcename=%_sourcedir/${1}_$4
	local mode=$2
	local dir=$3
	local name=$4

	[ ! -f $sourcename ] && return

	install -m $mode $sourcename $dir/$name
}

rm -f files.lst
for tmpl in %templates_list; do
	[ $tmpl = "os" ] && dir=%buildroot/%ostemplatedir || \
		dir=%buildroot/%templatedir/app/$tmpl/default

	mkdir -p $dir

	if [ $tmpl = "os" ]; then
		# Os template only files

		# Text
		echo "%fullname %fulltemplatearch Virtuozzo Template" > $dir/description
		echo "%fullname %fulltemplatearch Virtuozzo Template" > $dir/summary

		# Package manager
		echo "%package_manager" > $dir/package_manager
		echo "%technologies" > $dir/technologies
		# vzctl-related
		echo "%distribution" > $dir/distribution
		# Kernel virtualization
		echo "%osrelease" > $dir/osrelease

		# Disable upgrade
		touch $dir/upgradable_versions

		# Pkgman environment
		echo "%osenvironment" > $dir/environment

		# Os template cache scripts
		installfile $tmpl 0755 $dir pre-cache
		installfile $tmpl 0755 $dir post-cache
		installfile $tmpl 0755 $dir ct2vm
		installfile $tmpl 0755 $dir mid-pre-install
		installfile $tmpl 0755 $dir mid-post-install
		installfile $tmpl 0755 $dir pre-upgrade
		installfile $tmpl 0755 $dir post-upgrade
		# Installation sources
		echo '$SW_SERVER/download/mirrors/suse-es%{slesver}-x86_64' >> $dir/mirrorlist
		echo '$SW_SERVER/download/mirrors/updates-released-sles%{slesver}-x86_64' >> $dir/mirrorlist
		# how to pull SLES11_KEY_REL\UPD
		# curl -H "Authorization: Token token=xxxxxxxxx" https://scc.suse.com/connect/subscriptions/products | tr "," "\n" | grep -i "url" | grep -i "SLES11-SP4" | grep x86_64
		echo 'https://updates.suse.com/repo/$RCE/SLES11-SP4-Pool/sle-11-x86_64/?$SLES11_KEY_REL&ssl_capath=/vz/template/sles/11/x86_64/config/os/default/files/' >> $dir/repositories
		# Updates
		echo 'https://updates.suse.com/repo/$RCE/SLES11-SP4-Updates/sle-11-x86_64/?$SLES11_KEY_UPD&ssl_capath=/vz/template/sles/11/x86_64/config/os/default/files/' >> $dir/repositories
		# SDK
		echo 'https://updates.suse.com/repo/$RCE/SLE11-SDK-SP4-Pool/sle-11-x86_64/?$SLES11_SDK_REL&ssl_capath=/vz/template/sles/11/x86_64/config/os/default/files/' >> $dir/repositories
		echo 'https://updates.suse.com/repo/$RCE/SLE11-SDK-SP4-Updates/sle-11-x86_64/?$SLES11_SDK_UPD&ssl_capath=/vz/template/sles/11/x86_64/config/os/default/files/' >> $dir/repositories
		# how to obtain it
		# trust extract --format=openssl-directory --filter=ca-anchors --overwrite /tmp/certs/
		# pick 244b5494.0
		mkdir -p $dir/files/
		echo "-----BEGIN CERTIFICATE-----
MIIDrzCCApegAwIBAgIQCDvgVpBCRrGhdWrJWZHHSjANBgkqhkiG9w0BAQUFADBh
MQswCQYDVQQGEwJVUzEVMBMGA1UEChMMRGlnaUNlcnQgSW5jMRkwFwYDVQQLExB3
d3cuZGlnaWNlcnQuY29tMSAwHgYDVQQDExdEaWdpQ2VydCBHbG9iYWwgUm9vdCBD
QTAeFw0wNjExMTAwMDAwMDBaFw0zMTExMTAwMDAwMDBaMGExCzAJBgNVBAYTAlVT
MRUwEwYDVQQKEwxEaWdpQ2VydCBJbmMxGTAXBgNVBAsTEHd3dy5kaWdpY2VydC5j
b20xIDAeBgNVBAMTF0RpZ2lDZXJ0IEdsb2JhbCBSb290IENBMIIBIjANBgkqhkiG
9w0BAQEFAAOCAQ8AMIIBCgKCAQEA4jvhEXLeqKTTo1eqUKKPC3eQyaKl7hLOllsB
CSDMAZOnTjC3U/dDxGkAV53ijSLdhwZAAIEJzs4bg7/fzTtxRuLWZscFs3YnFo97
nh6Vfe63SKMI2tavegw5BmV/Sl0fvBf4q77uKNd0f3p4mVmFaG5cIzJLv07A6Fpt
43C/dxC//AH2hdmoRBBYMql1GNXRor5H4idq9Joz+EkIYIvUX7Q6hL+hqkpMfT7P
T19sdl6gSzeRntwi5m3OFBqOasv+zbMUZBfHWymeMr/y7vrTC0LUq7dBMtoM1O/4
gdW7jVg/tRvoSSiicNoxBN33shbyTApOB6jtSj1etX+jkMOvJwIDAQABo2MwYTAO
BgNVHQ8BAf8EBAMCAYYwDwYDVR0TAQH/BAUwAwEB/zAdBgNVHQ4EFgQUA95QNVbR
TLtm8KPiGxvDl7I90VUwHwYDVR0jBBgwFoAUA95QNVbRTLtm8KPiGxvDl7I90VUw
DQYJKoZIhvcNAQEFBQADggEBAMucN6pIExIK+t1EnE9SsPTfrgT1eXkIoyQY/Esr
hMAtudXH/vTBH1jLuG2cenTnmCmrEbXjcKChzUyImZOMkXDiqw8cvpOp/2PV5Adg
06O/nVsJ8dWO41P0jmP6P6fbtGbfYmbW0W5BjfIttep3Sp+dWOIrWcBAI+0tKIJF
PnlUkiaY4IBIqDfv8NZ5YBberOgOzW6sRBc4L0na4UU+Krk2U886UAb3LujEV0ls
YSEY1QSteDwsOoBrp+uvFRTp2InBuThs4pFsiv9kuXclVzDAGySj4dzp30d8tbQk
CAUw7C29C79Fv1C5qfPrmAESrciIxpg0X40KPMbp1ZWVbd4=
-----END CERTIFICATE-----" > $dir/files/399e7759.0
	else
		# App templates only files

		# Text
		echo "$tmpl for %fullname %fulltemplatearch Virtuozzo Template" > $dir/description
		echo "$tmpl for %fullname %fulltemplatearch Virtuozzo Template" > $dir/summary
	fi

	# Common things
	# Packages
	installfile $tmpl 0644 $dir packages

	# Scripts
	installfile $tmpl 0755 $dir pre-install
	installfile $tmpl 0755 $dir pre-install-hn
	installfile $tmpl 0755 $dir post-install
	installfile $tmpl 0755 $dir post-install-hn

	# Versioning
	echo "%release" > $dir/release
	echo "%version" > $dir/version
	%files_lst $dir files.lst
done

%files -f files.lst

%changelog
* Tue Apr 14 2020 Alexander Stefanov <atefanov@virtuozzo.com> 7.0.0-11
- Use modern cert to install packages to prevent ssl-cert errors
- bump release

* Thu Mar 9 2017 Alexander Stefanov <atefanov@virtuozzo.com> 7.0.0-10
- drop mariadb_packages, see #PSBM-61856
- bump release

* Fri Feb  3 2017 Konstantin Volkov <wolf@virtuozzo.com> 7.0.0-9
- Fixed mirrorlists, see #PSBM-59835

* Wed Feb 1 2017 Alexander Stefanov <astefanov@virtuozzo.com> 7.0.0-7
- remove yast2 modules renaming from os_post-install script
- and replace it with vzdummy-yast2 package to prevent upgrades of yast2, yast2-bootloader, etc
- bump rel, and add SW_REPOS, see #PSBM-59541

* Tue Jan 31 2017 Alexander Stefanov <atefanov@virtuozzo.com> 7.0.0-7
- Adjust devel_packages, see #PSBM-59480

* Fri Jan 27 2017 Denis Silakov <dsilakov@virtuozzo.com> 7.0.0-6
- Add SDK repos to vzpkg config #PSBM-59326

* Fri Jan 27 2017 Alexander Stefanov <astefanov@virtuozzo.com> 7.0.0-5
- add console to /etc/securetty #PSBM-59216

* Thu Jan 26 2017 Alexander Stefanov <astefanov@virtuozzo.com> 7.0.0-4
- add devel repos, see #PSBM-59225
- adjust database template
- rename mariadb_package to mysql_package, see #PSBM-59281
- adjust tomcat and java templates

* Wed Jan 25 2017 Alexander Stefanov <astefanov@virtuozzo.com> 7.0.0-3
- fix for #PSBM-59117
- redundant sysctl values, no need to point it in CT

* Fri Jan 20 2017 Alexander Stefanov <astefanov@virtuozzo.com> 7.0.0-2
- Use api token instead of login:password pair
- for more info see #PSBM-58881
- fix cert naming 399e7759.0 > 81b9768f.0

* Mon Dec 19 2016 Alexander Stefanov <astefanov@virtuozzo.com> 6.0.0-1
- initial version of sles 11 for vz7 platform
